#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "wisio.h"
#include "wappint.h"
#include "list.h"
#include "Wclass.h"

#define MARGINAL 2
#define MARGINAL2 (MARGINAL*2)
#define SCROLLMARGINAL 12
#define BS_KEY 8
int active_cid;
typedef struct
{
    LISTNODE hdr;
    int id;
    int line;
    int width;
    char text[64];
}
tnode;

class tobj : public tWobj
{
public:   int selcid,
             lastcid,
              todraw;
          int selheight,selwidth,
              scrollobj;
          LIST *menu;
          int pos,
              apos,
              spos,
              len,
              verscrl,
              autoclose,
              horisontal;
          int drawpos,drawwidth;             /* Tmp variables */ 
public:   char str[256];
public:   int  create(msg_win_cmd *pmes, int len);
public:   void update_ptr(int cid, int x, int y, int flags);
public:   void processkey(int cid, int key, int flags);
          int add_sel(int pcid, char *m);
          int put_sel(int cid, int sel, char *m);
          void show();
          void draw();
          void drawframes();
          tnode *getmenunode(int  cid);
          int  tobj::addlines(char *str);

virtual int  WCcreate(msg_win_cmd *pmes, int len);
virtual void WCmouse(int cid, int x, int y, int flags);
virtual void WCupdate(msg_win_cmd *pmes);
virtual void WCdelete(int cid, int idx, int items);
virtual void WCloop();
virtual int  WCdefault(msg_win_cmd *pmes, int len);
/*public:   int  WCmsgprocess();*/

//        virtual void WACremove();
};


int tobj::add_sel(int pcid, char *m)
{
    int cid;
    if (horisontal)
    {
       drawwidth = strlen(m) *8+8;
       cid =create_ctrl(MAINQUE,pcid,1,0,drawpos,0,drawwidth,selheight,64);
    }
    else
       cid =create_ctrl(MAINQUE,pcid,1,0,0,drawpos,drawwidth,selheight,64);
    WCadd_ctrltbl(cid,this);
    add_rect(CMD_ADDBAR,cid,0,0,0,drawwidth,selheight,15);
    add_text(CMD_ADDTXT,cid,64,WBTP_CO2,6,1,8,0,0,m);
    return cid;
}

int tobj::put_sel(int cid, int sel, char *m)
{
    
    if (sel)
    {
       add_rect(CMD_PUTBAR,cid,0,0,0,selwidth,selheight,1);
       add_text(CMD_PUTTXT,cid,1,WBTP_CO2,6,1,8,0,15,m);
    }
    else
       add_rect(CMD_PUTBAR,cid,0,0,0,selwidth,selheight,15);
       add_text(CMD_PUTTXT,cid,1,WBTP_CO2,6,1,8,0,0,m);
}

tnode *tobj::getmenunode(int  cid)
{
    int i;
    tnode *pnode;
    
    set_list(menu,0);
    for (i=1;pnode=(tnode*)get_list(menu,1);i++)
       if (pnode->id == cid)
          return pnode;
    return NULL;
}

void tobj::draw()
{
    int i,spos,epos;
    tnode *pnode;

    if (pos<apos)
    {
       spos = pos;
       epos = apos+len;
    }
    else
    {
       spos = apos;
       epos = pos+len;
    }
    set_list(menu,spos-1);
    for (i=spos,drawpos=0; i<=epos; i++)
    {
       pnode=(tnode*)get_list(menu,1);
       if (!pnode)
          break;
       if (i<pos || i>=pos+len)
       {
          if (pnode->id)
          {
             Wdel_ctrl(MAINQUE,pnode->id,0,0);
             pnode->id = 0; 
          }
          continue;
       }
       drawwidth = selwidth;
       if (pnode->id)
       {
          drawwidth = pnode->width;
          if (pnode->line != drawpos)
             Wput_ctrl(MAINQUE,pnode->id,WIN_CTRL,0,drawpos,selwidth,selheight);
       }
       else 
          pnode->id=add_sel(selcid,pnode->text);
       pnode->line =drawpos;
       pnode->width = drawwidth;
       if (horisontal)
          drawpos+=drawwidth;
       else
          drawpos+=selheight;
    }
    apos = pos;
}

void tobj::WCupdate(msg_win_cmd *pmes)
{
    pos = pmes->idx+1;
    todraw |= 1;
    WCsendloop();
}

void  tobj::drawframes()
{
    int cw,ch;

   if (width)
   {
      cw  = width;
      selwidth = cw-MARGINAL2;   
   }
   else
      cw  = selwidth+MARGINAL2;
   if (height)
   {
      if (horisontal)
         len = list_nodes(menu);
      else
         len = (height-MARGINAL2)/selheight;
      ch = height;      
   }
   else
   {
      len = list_nodes(menu);
      ch = len*selheight+MARGINAL2;
   }
   Wlog(65,"selwidth %d",selwidth);
    
   if (len<list_nodes(menu) && !horisontal)
   { 
      selwidth -= SCROLLMARGINAL;
      if (!scrollobj)
         scrollobj = Wopenobj("Wscroll");
      if (verscrl)
                Wputn_ctrl(scrollobj,verscrl,WIN_CTRL,
                           width-MARGINAL-SCROLLMARGINAL,MARGINAL,
                           SCROLLMARGINAL,height-MARGINAL2,
                           list_nodes(menu),len,NULL,0);
      else
         verscrl=Wadd_ctrl(scrollobj,cid,WIN_CTRL,
                           width-MARGINAL-SCROLLMARGINAL,MARGINAL,
                           SCROLLMARGINAL,height-MARGINAL2,
                           list_nodes(menu),len,NULL,0);
      WCadd_ctrltbl(verscrl,this);
   }
   else
      if(verscrl)
      {
         Wdel_ctrl(scrollobj,verscrl,0,0);
         verscrl=0;
      }
   Wlog(27,"NODES %d",list_nodes(menu));
/*   Wdel_ctrl(MAINQUE,cid,1,10);*/
   add_rect(CMD_PUTBAR,cid,1,0,0,MARGINAL,ch,0);            /* Update rectangel in menu control */
   add_rect(CMD_PUTBAR,cid,2,0,0,cw,MARGINAL,0); 
   add_rect(CMD_PUTBAR,cid,3,0,ch-MARGINAL,cw,MARGINAL,0);
   add_rect(CMD_PUTBAR,cid,4,cw-MARGINAL,0,MARGINAL,ch,0);
   Wput_ctrl(MAINQUE,selcid,WIN_CTRL,MARGINAL,MARGINAL,selwidth,ch-MARGINAL*2);
/*   add_rect(CMD_PUTBAR,selcid,0,cw-MARGINAL,0,MARGINAL,ch,0);*/
   Wput_ctrl(MAINQUE,cid,WIN_CTRL,posx,posy,cw,ch);
   draw();
}

int  tobj::addlines(char *str)
{
    int cw,ch;
    tnode *pnode;
    char *m;

    set_list(menu,list_nodes(menu));
    m=str;
    while(*str)
    {
       if (*str=='|' || *str == '\r')
       {
          *str++=0;
          pnode=(tnode*)add_list(menu,sizeof(tnode));
          strcpy(pnode->text,m);
          pnode->id=0; 
          pnode->line = 0;

          if(selwidth < 8*strlen(pnode->text)+8)
             selwidth = 8*strlen(pnode->text)+8;
          m=str;
       }  
       else
          str++;
   }
   if (*m)
   {
      pnode=(tnode*)add_list(menu,sizeof(tnode));
      strcpy(pnode->text,m);
      pnode->line = 0;
      pnode->id=0; 
   }
   todraw |= 2;
   WCsendloop();

}

int  tobj::create(msg_win_cmd *pmes, int msglen)
{

//   items = 64;
   tWobj::WCcreate(pmes,msglen);


   add_rect(CMD_ADDBAR,cid,1,0,0,0,0,0);       
   add_rect(CMD_ADDBAR,cid,2,0,0,0,0,0);
   add_rect(CMD_ADDBAR,cid,3,0,0,0,0,0);
   add_rect(CMD_ADDBAR,cid,4,0,0,0,0,0);

   selcid =create_ctrl(MAINQUE,cid,0,0,0,0,0,0,64);
   WCadd_ctrltbl(cid,this);
   add_rect(CMD_ADDBAR,selcid,0,0,0,640,480,15);
   menu = new_list();
   posx = pmes->x;
   posy = pmes->y;
   ppid = pmes->pid;
   lastcid = 0;
   scrollobj = 0;
   width = pmes->dx;
   horisontal = pmes->flg & CTRL_HORISONT;
   selwidth = 0;
   selheight = 12;
   verscrl  = 0;
   autoclose = 1;
   height= pmes->dy;
   if (height)    
      autoclose = 0;

   addlines((char*)pmes->data);  

   Wsendcmd(MAINQUE,CMD_ACTCTL,cid,0,1,PEND);
   pos=1;
   apos=1;
}



int  tobj::WCcreate(msg_win_cmd *pmes, int msglen)
{
   tobj *pobj;
   pobj = new(tobj);
   pobj->create(pmes,msglen);
}


void tobj::WCmouse(int ucid, int x, int y, int flags)
{
   int idx;
   tnode *pnode;

   pnode = getmenunode(ucid);
   if( pnode)
   {
      if (flags & 64)
      {
	 put_sel(ucid,0,pnode->text);
         if (lastcid == ucid)
            lastcid = 0;
      }
      else
      {
	 if (ucid != lastcid)
	 {
            lastcid = ucid;
	    put_sel(ucid,1,pnode->text);
	    Wsendcmd(MAINQUE,CMD_TRCPTR,ucid,0,2,PEND);
	 }
      }
      if (flags==4)
      {
         if (active_cid == cid)
         {
            WAPupdate(cid,ppid,pnode->text,0,pnode->line);
//          if (autoclose)
 //            Wsendcmd(MAINQUE,CMD_DELTSK,PEND);
         }
         else
         {
            Wsendcmd(MAINQUE,CMD_ACTCTL,ucid,0,1,PEND);
         }
         lastcid =ucid;
      }
   }
}


void tobj::WCdelete(int cid, int idx, int items)
{
    tnode *pnode;
    int i;

    
    if (!menu)
       return;
    set_list(menu,idx);
    for (i=0; i<items; i++)
    {
       pnode=(tnode*)get_list(menu,0);
       if (!pnode)
          break;
       if (pnode->id)
          Wdel_ctrl(MAINQUE,pnode->id,0,0);
       del_list(menu);
    }
    draw();
}

void tobj::WCloop()
{
    if (todraw > 1)
       drawframes();    
    else
       draw();
    todraw = 0;
}
/*
void tobj::WACremove()
{
     active_cid = 0;
     Wdel_ctrl(MAINQUE, cid, 0, 0);
     Wsenddim(ppid,CMD_WAPEND,cid,ENDD);
     WCdel_ctrltbl(this);
}
*/
int tobj::WCdefault(msg_win_cmd *pmes, int len)
{
   char text[4];
   int idx;
   tobj *pobj;
   tnode *pnode;
   
   switch (pmes->cmd)
   {
      case CMD_ACTCTL:
         Wlog(52,"ACTIVATE %d %d %d",pmes->cid,lastcid,pmes->flg);
         pobj=(tobj*)WCget_ctrltbl(pmes->cid);
         if (pobj)
         {
            if(pmes->flg & 1)
            {
               Wlog(52,"LASTCID  %d",lastcid);
               if (pmes->cid == lastcid)
               {
                  pnode = getmenunode(pmes->cid);
                  if (pnode)  
                  Wlog(52,"WMENU idx %d %s",idx,pnode->text);
                  if (pnode)
                     WAPupdate(cid,ppid,pnode->text,0,pnode->line);
//                     Wsenddat(pobj->ppid,CMD_WAPUPD,pobj->cid,pnode->text,0,ENDD);
                  lastcid = 0;
               }
               active_cid = cid;
            }
            else
            {
               if (pobj->autoclose)
               {
                  Wlog(27,"AUTOCLOSE");
                  WAPupdate(cid,ppid,"",0,0);
//                  Wsendcmd(MAINQUE,CMD_DELTSK,PEND);
               }
               active_cid = 0;
            }
         }
         break;
      case CMD_ADDKEY:
            break;
      case CMD_UPDCTL:
         pobj=(tobj*)WCget_ctrltbl(pmes->cid);
         if (pobj)
            pobj->WCupdate(pmes);
         break;
      case CMD_ADDTXT:
         pobj=(tobj*)WCget_ctrltbl(pmes->cid);
         Wlog(42,"WCdefault %d %x %x %s",pmes->cid,pobj,this,pmes->data);
         if (pobj)
            pobj->addlines((char*)pmes->data);
         break;
      default:
         return 1;
      }
      return 0;
}

main(int argc,char *argv[])
{
   tobj mainobj;
   Wloglevel = 66;
   mainobj.WCmsgprocess();
}

